

import { registerVerify, phoneRegister } from '../../api/api.js';

const app=getApp();

Page({
  /**
   * 页面的初始数据
   */
  data: {
    parameter: {
      'navbar': '1',
      'return': '0',
      'title': '注册',
      'color': true,
      'class': '6'
    },
    loading: false,
    disabled: false,
    active: false,
    timetext: '获取验证码',
    userInfo: {},
    phone: '', //手机号
    spread: '', //邀请码
    
  },
  getPhoneValue: function (e) {
    this.setData({
      phone: e.detail.value
    })
  },
  /**
  * 生命周期函数--监听页面加载
  */
  onLoad: function (options) {
    var spread = options.scene;
    this.setData({
      spread: spread
    })
  },
  /**
   * 发送验证码
   * 
  */
  code: function () {
    let that = this;
    if (!that.data.phone) return app.Tips({ title: '请先输入手机号' });

    var type = 'register';
    registerVerify(that.data.phone, type).then(res => {
      return app.Tips({ title: '发送成功' }, function () {
        that.setData({ disabled: true, active: true });
        let n = 60;
        let run = setInterval(function () {
          n--;
          if (n < 0) {
            clearInterval(run);
            that.setData({ disabled: false, active: false, timetext: '重新获取' })
          } else {
            that.setData({ timetext: "剩余 " + n + "s" })
          }
        }, 1000);
      });
    }).catch(err => {
      return app.Tips({ title: err });
    });
  },
  loginSubmit: function (e) {

    var that = this, data = {};
    var datainfo = e.detail.value;
    if (!datainfo.account) return app.Tips({ title: '请先输入手机号' });
    if (!datainfo.password) return app.Tips({ title: '请输入密码' });
    if (!datainfo.captcha) return app.Tips({ title: '请输入验证码' });
    phoneRegister(datainfo).then(res => {
      // wx.setStorageSync('token', res.data.token);
      return app.Tips({ title: '注册成功！' }, function () {
        wx.switchTab({ url: '/pages/index/index' });
      });

    }).catch(err => {
      return app.Tips({ title: err });
    })
  },


  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },


  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  }
})